#include <stdio.h>
#include <math.h>

#define S 10

int filterPositive(int n, double a[n], double b[n]);
void printArray(int n, double a[n]);
void mapToSquares(int n, double a[n], double b[n]);
double reduceToSum(int n, double a[n]);

int main() {

    double a[S] = {1, -2, 3, -4, 5, -6, -7, 8, 0, 0};
    double b[S];

    int k = filterPositive(S, a, b);
    printArray(S, a);
    printArray(k, b);
    return 0;
}

int filterPositive(int n, double a[n], double b[n]) {
    int j=0;
    for (int i = 0; i < n; ++i) {
        if (a[i] > 0) {
            b[j] = a[i];
            j++;
        }
    }
    return j;
}

int filterNegative(int n, double a[n], double b[n]) {
    int j=0;
    for (int i = 0; i < n; ++i) {
        if (a[i] < 0) {
            b[j] = a[i];
            j++;
        }
    }
    return j;
}

int filterMultiples2(int n, double a[n], double b[n]) {
    int j=0;
    for (int i = 0; i < n; ++i) {
        if (fmod(a[n], 2.0) == 0) {
            b[j] = a[i];
            j++;
        }
    }
    return j;
}

void printArray(int n, double a[n]) {
    for (int i = 0; i < n; ++i) {
        printf("%lf ", a[i]);
    }
    printf("\n");
}

void mapToSquares(int n, double a[n], double b[n]) {
    for (int i = 0; i < n; ++i) {
        b[i] = a[i] * a[i];
    }
}

void mapToMultiple(double M, int n, double a[n], double b[n]) {
    for (int i = 0; i < n; ++i) {
        b[i] = a[i] * M;
    }
}

double reduceToSum(int n, double a[n]) {
    double result = 0.0;
    for (int i = 0; i < n; ++i) {
        result +=a[i];
    }
    return result;
}

double reduceToProd(int n, double a[n]) {
    double result = 1.0;
    for (int i = 0; i < n; ++i) {
        result *= a[i];
    }
    return result;
}

